/*
 * DataProvider.java
 *
 * Created on 15. kvten 2005, 22:34
 */

package cz.matfyz.sykora.nngui.data;

import cz.matfyz.sykora.nngui.exception.*;

/**
 * Interface pro abstraktn zdroj dat pro neuronovou s. Doke inicializovat
 * dek hodnot (zznam) ze vstupnho souboru, lze se dotazovat na jednotliv
 * hodnoty na dku.
 *  @author Ondej Skora [ondrasej@centrum.cz]
 */
public interface DataProvider {
    /**
     * Uzaven vstupnho souboru. Mla by bt volna ve chvli, kdy u uivatel
     * tohoto provideru nechce st dal vstup. Umouje tak uvolnit nepotebn
     * prostedky, ppadn rozit informaci o ukonen ten mezi dal
     * objekty, kter provider pouv
     */
    public void close();
    /**
     * Pomocn funkce, jejm zavolnm je provider informovn, e bylo ukoneno
     * zpracovn aktuln dky a e m pipravit pro zpracovn dal zznam
     * ze vstupnho souboru dat
     *  @return false pokud je vstupn soubor dat przdn, jinak true
     */
    public boolean fetchRow() throws DataException;
    /**
     * Zjitn velikosti zznamu ze vstupnho souboru dat. Tato hodnota mus
     * bt stejn pro vechny zznamy
     *  @return poet selnch hodnot v jednom zznamu vstupnho souboru
     */
    public int getRowSize();
    /**
     * Dotaz na konkrtn selnou hodnotu z prv zpracovanho zznamu ze
     * vstupnho souboru dat
     *  @param _index index seln hodnoty na kterou se dotazujeme. Prvn
     *              hodnota m index 0, posledn getRowSize() - 1
     *  @return selnou hodnotu s indexem <i>_index</i>
     */
    public double getValue(int _index) throws DataException;
    /**
     * Provede petoen providera zpt na zatek souboru dat (take se budou
     * vechny vzorky st znovu od zatku. Pokud provider nepodporuje
     * peten, vrac vdy false.
     *  @return true pokud bylo mon rewind provst, jinak false
     */
    public boolean rewind();
}
