/*
 * NullDataConsumer.java
 *
 * Created on 18. kvten 2005, 22:46
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package cz.matfyz.sykora.nngui.data;

/**
 * Nulov konzument pro data. Nic s nimi nedl a jak je dostane, tak je hned
 * zahod. Je uiten v ppad, kdy clem prce se st nen zpracovn jejho
 * vstupu, ale pouze jej uen (vstup vpotu nen ve vstupu st, ale v
 * jejch vahch).
 * Pitom ale testuje, jestli komunikace s nm probh rozumnm zpsobem (platn
 * indexy neuron, platn data), take ho je mon pout i pro leh testovn
 *  @author Ondej Skora [ondrasej@centrum.cz]
 */
public class NullDataConsumer implements DataConsumer {
    
    /**
     * Nastaven ka zznamu v konzumentovi. ku zznamu je mon nastavit
     * jen jednou, kad dal jej nastaven na jinou hodnotu znamen chybu
     *  @see #getRowSize
     *  @see #setRowSize
     */
    int storedRowSize = 0;
    
    /**
     * Uzaven nulovho konzumenta. Nem co dlat, tak skuten nic nedl
     */
    public void close() {
        
    }
    
    /**
     * Potvrzen zadan dky. Vdy s spchem projde, do nulovho konzumenta
     * jde nacpat neomezen poet dek.
     *  @return true za vech okolnost
     */
    public boolean commitRow() {
        return true;
    }
    
    /**
     * Zjitn velikosti zznamu, kter kozument aktuln pijm.
     *  @return velikost zznamu konzumenta
     */
    public int getRowSize() {
        return storedRowSize;
    }

    /**
     * Nastaven velikosti zznamu pro konzumenta. Prvn nastaven projde vdy,
     * dal povol pouze pokud jsou stejn jeko ji nastaven velikost.
     *  @param _size nov nastavovan velikost zznamu konzumenta
     */
    public boolean setRowSize(int _size) {
        if(storedRowSize == 0) {
            storedRowSize = _size;
            return true;
        }
        else
            return storedRowSize == _size;
    }
    
    /**
     * Pedn hodnoty zznamu konzumentovi. Pouze zkontroluje, jestli je index
     * v nastavenm rozsahu a dl nedl nic.
     *  @param _index index pedvan hodnoty v aktulnm zznamu
     *  @param _value pedvan hodnota
     */
    public void setValue(int _index, double _value) {
        if(_index < 0 || _index >= storedRowSize)
            throw new IndexOutOfBoundsException();
    }
}
