/*
 * DataProviderNotReadyException.java
 *
 * Created on 20. kvten 2005, 17:11
 */

package cz.matfyz.sykora.nngui.exception;

import cz.matfyz.sykora.nngui.data.DataProvider;

/**
 * Vjimka vyhazovan ve chvli, kdy se pokoume st z datovho zdroje, kter
 * jet nebyl inicializovn, tj. nebyla na nm ani jednou volna metoda
 * <i>fetchRow</i>.
 *  @author Ondej Skora [ondrasej@centrum.cz]
 */
public class DataProviderNotReadyException extends DataException {
    
    /**
     * Odkaz na providera, ze kterho jsme se pokoueli st jet ped
     * inicializac pomoc <i>fetchRow</i>
     *  @see DataProvider#fetchRow
     */
    private DataProvider source;
    
    /**
     * Konstruktor
     *  @param _source provider, dky ktermu je tato vjimka vyvolan
     */
    public DataProviderNotReadyException(DataProvider _source) {
        super("Data source was not initialized!");
        
        source = _source;
    }
    
}
