/*
 * AdaptationStrategy.java
 *
 * Created on 9. kvten 2005, 22:52
 */

package cz.matfyz.sykora.nngui.network;

import javax.swing.*;

/**
 * Interface pro tdy implementujc adaptaci neuron v sti. Vyuv se zde
 * nvrhov vzor strategie
 *  @author Ondej Skora [ondrasej@centrum.cz]
 */
public interface AdaptationStrategy {
    /**
     * Adaptece jednoho neuronu. Pedpokld se, e vechna funknost je skryta
     * ve td implementujc tento interface
     *  @param _neuron adaptovan neuron
     */
    public void adaptNeuron(Neuron _neuron);
    /**
     * Zskn panelu obsahujcho ovldac prvky pro nastaven adaptan
     * strategie. V uivatelskm rozhran je zobrazen panel s nastavenm pro
     * aktuln vybranou adaptan strategii
     *  @return panel s ovldacmi prvky pro nastaven parametr adaptace, nebo
     *          null, pokud adaptace dn parametry nem
     */
    public JPanel getSettingsPanel();
}
